
local Mouse = {}


function Mouse:load()

	--local mouse = {}
	gameloop:addLoop(self)
	self.pressedPos = {x = 0, y = 0}

end


function Mouse:tick(dt)
	--self.uiElement = nil
end


function Mouse:getPosition()
	return love.mouse.getPosition()
end


-- get the world coordinates from the local mouse position
function Mouse:getWorldPosition()
	local x, y = self.getPosition()
	local cx, cy = cam:getPosition()
	local sx, sy = cam:getScale()
	x = cx + (x - love.graphics.getWidth() / 2) * sx
	y = cy + (y - love.graphics.getHeight() / 2) * sy
	return x, y
end

--[[
function Mouse:getWorldPosition()
	local x, y = self.getPosition()
	local cx, cy = cam:getPosition()
	x = x + cx - love.graphics.getWidth() / 2
	y = y + cy - love.graphics.getHeight() / 2
	return x, y
end
--]]


function love.mousepressed( x, y, button, istouch, presses )
	
	Mouse:pressed( x, y, button, istouch, presses )
	
end

function Mouse:pressed( x, y, button, istouch, presses )
	
	if button == 1 then
		-- store the position where the mouse press started (for GUI interactions)
		local mx, my = self:getPosition()
		self.pressedPos = {x = mx, y = my}
		
	end
	
end


function love.mousereleased( x, y, button, istouch, presses )

	--Mouse:released( x, y, button, istouch, presses )
	
end

function Mouse:released( x, y, button, istouch, presses )

end



return Mouse
