-- entity

local Entity = {}

function Entity:create(_entity)
	local entity = {}

	--print("creating entity named ".. _entity.id .." at " .. (_entity.x or 0) .. ";" .. (_entity.y or 0))
	--entity.id			= _entity.id or "Entity" .. math.random(100, 999999)
	if _entity.id ~= nil then
		entity.id		= _entity.id
	end
	entity.playerID		= _entity.id
	entity.x			= _entity.x or 0
	entity.y			= _entity.y or 0
	entity.radius		= _entity.radius or 0
	entity.height		= _entity.height or 0
	entity.width		= _entity.width or 0
	entity.orientation	= _entity.orientation or 0
	entity.visible		= _entity.visible or true
	--entity.remove		= false

--	function entity:load(_id) end
--	function entity:tick(dt) end
--	function entity:draw() end
	
	function entity:destroy()
		gameloop:removeLoop(self)
		renderer:removeRenderer(self)
		--self.remove = true
		objmgr:destroyObject(self.id)
	end
	

	return entity
end


return Entity