local Imageloader = {}

Imageloader.images = {}

Imageloader.images["player1"] = {love.graphics.newImage("assets/graphics/player1.png")}
Imageloader.images["player2"] = {love.graphics.newImage("assets/graphics/player2.png")}


-- static
Imageloader.images["main_mask1"] = {love.graphics.newImage("assets/graphics/main_mask1.png")}
Imageloader.images["block1"] = {love.graphics.newImage("assets/graphics/block1.png")}
Imageloader.images["block2"] = {love.graphics.newImage("assets/graphics/block2.png")}
Imageloader.images["grass1"] = {love.graphics.newImage("assets/graphics/grass1.png")}
Imageloader.images["stone1"] = {love.graphics.newImage("assets/graphics/stone1.png")}
Imageloader.images["stone2"] = {love.graphics.newImage("assets/graphics/stone2.png")}

-- GUI elements
Imageloader.images["button1"] = {love.graphics.newImage("assets/graphics/button1.png")}
Imageloader.images["slider1"] = {love.graphics.newImage("assets/graphics/slider1.png")}


-- animated
Imageloader.images["water1"] = {}
Imageloader.images["water1"][1] = love.graphics.newImage("assets/graphics/uglywater1.png")
Imageloader.images["water1"][2] = love.graphics.newImage("assets/graphics/uglywater2.png")

Imageloader.images["grass2"] = {}
Imageloader.images["grass2"][1] = love.graphics.newImage("assets/graphics/grass2_1.png")
Imageloader.images["grass2"][2] = love.graphics.newImage("assets/graphics/grass2_2.png")

Imageloader.images["bat1"] = {}
Imageloader.images["bat1"][1] = love.graphics.newImage("assets/graphics/bat1_1.png")
Imageloader.images["bat1"][2] = love.graphics.newImage("assets/graphics/bat1_2.png")

Imageloader.images["spider1"] = {}
Imageloader.images["spider1"][1] = love.graphics.newImage("assets/graphics/spider1_1.png")
Imageloader.images["spider1"][2] = love.graphics.newImage("assets/graphics/spider1_2.png")

Imageloader.images["zombie1"] = {}
Imageloader.images["zombie1"]["up"] = {}
Imageloader.images["zombie1"]["up"][1] = love.graphics.newImage("assets/graphics/zombie1_up_1.png")
Imageloader.images["zombie1"]["up"][2] = love.graphics.newImage("assets/graphics/zombie1_up_2.png")
Imageloader.images["zombie1"]["left"] = {}
Imageloader.images["zombie1"]["left"][1] = love.graphics.newImage("assets/graphics/zombie1_left_1.png")
Imageloader.images["zombie1"]["left"][2] = love.graphics.newImage("assets/graphics/zombie1_left_2.png")
Imageloader.images["zombie1"]["right"] = {}
Imageloader.images["zombie1"]["right"][1] = love.graphics.newImage("assets/graphics/zombie1_right_1.png")
Imageloader.images["zombie1"]["right"][2] = love.graphics.newImage("assets/graphics/zombie1_right_2.png")
Imageloader.images["zombie1"]["down"] = {}
Imageloader.images["zombie1"]["down"][1] = love.graphics.newImage("assets/graphics/zombie1_down_1.png")
Imageloader.images["zombie1"]["down"][2] = love.graphics.newImage("assets/graphics/zombie1_down_2.png")


-- masks
--Imageloader.images["mask1111"] = love.graphics.newImage("assets/graphics/testmask.png")	-- not needed (no mask)
Imageloader.images["mask0000"] = love.graphics.newImage("assets/graphics/mask0000.png")
Imageloader.images["mask0001"] = love.graphics.newImage("assets/graphics/mask0001.png")
Imageloader.images["mask0010"] = love.graphics.newImage("assets/graphics/mask0010.png")
Imageloader.images["mask0011"] = love.graphics.newImage("assets/graphics/mask0011.png")
Imageloader.images["mask0100"] = love.graphics.newImage("assets/graphics/mask0100.png")
Imageloader.images["mask0101"] = love.graphics.newImage("assets/graphics/mask0101.png")
Imageloader.images["mask0110"] = love.graphics.newImage("assets/graphics/mask0110.png")
Imageloader.images["mask0111"] = love.graphics.newImage("assets/graphics/mask0111.png")
Imageloader.images["mask1000"] = love.graphics.newImage("assets/graphics/mask1000.png")
Imageloader.images["mask1001"] = love.graphics.newImage("assets/graphics/mask1001.png")
Imageloader.images["mask1010"] = love.graphics.newImage("assets/graphics/mask1010.png")
Imageloader.images["mask1011"] = love.graphics.newImage("assets/graphics/mask1011.png")
Imageloader.images["mask1100"] = love.graphics.newImage("assets/graphics/mask1100.png")
Imageloader.images["mask1101"] = love.graphics.newImage("assets/graphics/mask1101.png")
Imageloader.images["mask1110"] = love.graphics.newImage("assets/graphics/mask1110.png")

Imageloader.imageCount = #Imageloader.images



return Imageloader