entity = require "scripts/entity"

local Item = {}

function Item:create(_id, _x, _y)
	local item = entity:create({id = _id, x=_x, y=_y})
	
	function item:load()
		gameloop:addLoop(self)
		renderer:addRenderer(self, LAYERITEMS)
		self.id = _id
		self.image = love.graphics.newImage("assets/graphics/coin1.png")
		self.size = 16
		self.imageScale = self.size / self.image:getHeight()
	end
	
	function item:tick(dt)
		
	end
	
	function item:draw()
		-- drawable, x, y, rotation, scale x/y, offset x/y, shearing factor x/y
		love.graphics.draw(self.image, self.x, self.y, 0, self.imageScale, self.imageScale, 0, 0)
		--love.graphics.rectangle("line", self.x, self.y, self.size, self.size)
		
		--print("item get = " .. self.body:getX() .. ";" .. self.body:getY() .. "pos: " ..self.x .. ":" ..self.y)
	end
	
	return item
end


return Item