--entity = require "scripts/entity"
mapobject = require "scripts/mapobject"
imageloader = require "scripts/imageloader"

local Stone = {}

function Stone:create(_x, _y)
	local stone = mapobject:create({x=_x, y=_y})
	stone.entityType = "stone"

	stone.traversableGround = true
	stone.traversableAir = true
	stone.blocking = false
	stone.canSpawnMobs = true
	stone.canSpawnItems = true
	
	stone.image = imageloader.images["stone1"][1]

	function stone:tick(dt)
		
	end
	
	function stone:draw()
		-- drawable, x, y, rotation, scale x/y, offset x/y, shearing factor x/y
		love.graphics.draw(self.image, self.x, self.y, 0, 1, 1, 0, 0)
		
	end
	
	return stone
end


return Stone